<?
	session_start();
	
	$commentValidation_width = 90;
	$commentValidation_height = 70;
	$commentValidation_noOfRandLines = 5;
	$commentValidation_pixelnum = 1500;
	$commentValidation_fontSize = 15;
	$commentValidation_noOfCharsInCode = 6;	

	// The text to draw
	$captcha_content = substr(strtoupper(md5("Mytext".rand(1234, 9999))), 0, $commentValidation_noOfCharsInCode);

	//Replace hard to read characters: replace zero, upper o, D, 1, 8, B
	$search  = array('0', 'O', 'D', '1', '8', 'B');
	$replace = array('H', 'K', 'R', 'X', 'V', 'W');
	
	//Do the replacement
	$captcha_content = str_replace($search, $replace, $captcha_content);
	
	$_SESSION['captcha_doce'] = $captcha_content;
	
	//Create lines
	function imagelinethick($image, $x1, $y1, $x2, $y2, $color, $thick = 1)
	{
		if ($thick == 1)
			return imageline($image, $x1, $y1, $x2, $y2, $color);

		$t = $thick / 2 - 0.5;

		if ($x1 == $x2 || $y1 == $y2)
			return imagefilledrectangle($image, round(min($x1, $x2) - $t), round(min($y1, $y2) - $t), round(max($x1, $x2) + $t), round(max($y1, $y2) + $t), $color);

		$k = ($y2 - $y1) / ($x2 - $x1);
		$a = $t / sqrt(1 + pow($k, 2));

		$points = array(
			round($x1 - (1+$k)*$a), round($y1 + (1-$k)*$a),
			round($x1 - (1-$k)*$a), round($y1 - (1+$k)*$a),
			round($x2 + (1+$k)*$a), round($y2 - (1-$k)*$a),
			round($x2 + (1-$k)*$a), round($y2 + (1+$k)*$a),
		);
		
		imagefilledpolygon($image, $points, 4, $color);
		return imagepolygon($image, $points, 4, $color);
	}
		
	// Create an image
	$im = imagecreatetruecolor($commentValidation_width, $commentValidation_height);
	
	// Create a few colors
	$white = imagecolorallocate($im, 255, 255, 255);
	$grey = imagecolorallocate($im, 128, 128, 128);
	$black = imagecolorallocate($im, 0, 0, 0);
	imagefilledrectangle($im, 0, 0, $commentValidation_width-1, $commentValidation_height-1, $white);

	$font = './courbd.ttf';
	//More ttf fonts on http://www.google.com/fonts
	
	$rotation_degrees = array();
	$rotation_degrees[0] = rand(330,360);
	$rotation_degrees[1] = rand(0,30);
	
	$rotation = $rotation_degrees[rand (0,1)];
	
	// Add some shadow to the text
	//imagettftext($im, $commentValidation_fontSize, $rotation, 6, 41, $grey, $font, $captcha_content);
	
	// Add the text
	imagettftext($im, $commentValidation_fontSize, $rotation, 5, 40, $black, $font, $captcha_content);
	
	// Add random pixels
	for ($j=0; $j<$commentValidation_pixelnum; $j++) 
	{
		$color = imagecolorallocate($im, rand(0,255), rand(0,255), rand(0,255));
		imagesetpixel($im, rand(0,$commentValidation_width), rand(0,$commentValidation_height), $color);
	}
	
	// Add random lines
	for ($j=0; $j<$commentValidation_noOfRandLines; $j++) 
	{
		$color = imagecolorallocate($im, rand(0,255), rand(0,255), rand(0,255));
		imagelinethick($im, rand(0,69), rand(0,69), rand(0,69), rand(0,69), $color, 1);
	}
	
	//produce 4 rand letters
	$decoy = substr(strtoupper(md5("Mytext".rand(1234, 9999))), 0, 4);
	
	// Add almost white rand chars not included in the captcha
	$almost_white = imagecolorallocate($im, 240, 240, 240);
	imagettftext($im, $commentValidation_fontSize, 0, 0, $commentValidation_fontSize, $almost_white, $font, substr($decoy,0,1));
	imagettftext($im, $commentValidation_fontSize, 0, 0, $commentValidation_height, $almost_white, $font, substr($decoy,1,1));
	imagettftext($im, $commentValidation_fontSize, 0, $commentValidation_width-$commentValidation_fontSize, $commentValidation_fontSize, $almost_white, $font, substr($decoy,2,1));
	imagettftext($im, $commentValidation_fontSize, 0, $commentValidation_width-$commentValidation_fontSize, $commentValidation_height, $almost_white, $font, substr($decoy,3,1));	
	
	//Set the headers right
	header('Content-Type: image/png');
	
	//Output the image
	imagepng($im);
	
	//Free memory 
	imagedestroy($im);
?>